declare module "apex-shared" {

    export interface Thing {

        _id: string;
        name?: string;
        description?: ThingDescription;
        createdAt?: string;
        updatedAt?: string;
        tags?: Array<string>;
    }

    export interface ThingDescription {

        description?: string;
        properties?: Array<ThingProperty>;
        actions?: Array<ThingAction>;
        events?: Array<ThingEvent>;
    }

    export interface ThingProperty {

        id: string;
        name?: string;
        description?: string;
        type: "string" | "number" | "boolean";
        unit?: string;
        href: string;
    }

    export interface ThingPropertyValue {

        id: string;
        name?: string;
        values: Object;
    }

    export interface ThingAction {

        id: string;
        name?: string;
        description?: string;
        params?: [{

            name: string;
            description?: string;
            type?: "string" | "number" | "boolean"
        }];
    }

    export interface ThingActionExecution {

        id: string;
        params?: [{

            name: string;
            value: string;
        }];
        status: "pending" | "executing" | "completed" | "false";
        timestamp: string;
    }

    export interface ThingEvent {

        id: string;
        name?: string;
        description?: string;
    }
}